'use strict';

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _cell = require('./component/cell');

var _cell2 = _interopRequireDefault(_cell);

var _toast = require('./component/toast');

var _toast2 = _interopRequireDefault(_toast);

var _loading = require('./component/loading');

var _loading2 = _interopRequireDefault(_loading);

var _validator = require('./component/validator');

var _validator2 = _interopRequireDefault(_validator);

var _upload = require('./component/upload');

var _upload2 = _interopRequireDefault(_upload);

var _progress = require('./component/progress');

var _progress2 = _interopRequireDefault(_progress);

var _toast3 = require('./plugin/toast');

var _toast4 = _interopRequireDefault(_toast3);

var _loading3 = require('./plugin/loading');

var _loading4 = _interopRequireDefault(_loading3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function plugin(Vue, opts) {
    if (plugin.installed) {
        return;
    }

    opts = (0, _assign2.default)({}, {
        config: {},
        exclude: []
    }, opts);

    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
        for (var _iterator = (0, _getIterator3.default)((0, _keys2.default)(plugin.plugins)), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var key = _step.value;

            if (opts.exclude.indexOf(key) === -1) {
                if (opts.config[key]) {
                    Vue.use(plugin.plugins[key], opts.config[key]);
                } else {
                    Vue.use(plugin.plugins[key]);
                }
            }
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
            }
        } finally {
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }

    var _iteratorNormalCompletion2 = true;
    var _didIteratorError2 = false;
    var _iteratorError2 = undefined;

    try {
        for (var _iterator2 = (0, _getIterator3.default)((0, _keys2.default)(plugin.components)), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            var _key = _step2.value;

            Vue.component(_key, plugin.components[_key]);
        }
    } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion2 && _iterator2.return) {
                _iterator2.return();
            }
        } finally {
            if (_didIteratorError2) {
                throw _iteratorError2;
            }
        }
    }
}

plugin.plugins = {
    toast: _toast4.default,
    loading: _loading4.default
};
plugin.components = {
    Cell: _cell2.default,
    Toast: _toast2.default,
    Loading: _loading2.default,
    Validator: _validator2.default,
    Upload: _upload2.default
};

if (typeof window !== 'undefined' && window.Vue) {
    window.Vue.use(plugin);
}

module.exports = plugin;