import Cell from './component/cell'
import Toast from './component/toast'
import Loading from './component/loading'
import Validator from './component/validator'
import Upload from './component/upload'
import Progress from './component/progress'

import toast from './plugin/toast'
import loading from './plugin/loading'

function plugin(Vue, opts) {
    if(plugin.installed) {
        return
    }

    opts = Object.assign({}, {
        config: {},
        exclude: []
    }, opts)

    for(let key of Object.keys(plugin.plugins)) {
        if(opts.exclude.indexOf(key) === -1) {
            if(opts.config[key]) {
                Vue.use(plugin.plugins[key], opts.config[key])
            }else {
                Vue.use(plugin.plugins[key])
            }
        }
    }

    for(let key of Object.keys(plugin.components)) {
        Vue.component(key, plugin.components[key])
    }
}

plugin.plugins = {
    toast,
    loading
}
plugin.components = {
    Cell,
    Toast,
    Loading,
    Validator,
    Upload
}

if(typeof window !== 'undefined' && window.Vue){
    window.Vue.use(plugin)
}

module.exports = plugin
